; tabstop=8
;
;
	ORG	0E000H


	JP	START
;
;
SONGDATADD:	DW	03E8H
TALKMODE:	DB	00H
ERRFLAG:	DB	00H

SONGLENDATADD:	EQU	0019H
SONGLENADD:	EQU	0011H


;
; voice data output
; C <- voice data
;
; RETURN : Cflag=1 ERROR

OUTDT:
	IN	A,(0E0H)
	BIT	4,A
	SCF
	RET	NZ
	BIT	6,A
	JR	Z,OUTDT
	LD	A,C
	OUT	(0E0H),A
	OR	A
	RET


START:
	LD	A,0FFH
	LD	(ERRFLAG),A
	LD	A,(TALKMODE)
	OUT	(0E2H),A	; set mode (speed)
	LD	A,0FEH
	OUT	(0E3H),A	; set external data

	DI
	LD	A,0DDH
	OUT	(0F0H),A	; 0x0000-0x3FFF RAM read

	LD	A,(SONGLENADD)
	LD	E,A		; E <= SONG data num
	LD	IY,SONGLENDATADD; IY <= SONG length data address
	LD	HL,(SONGDATADD)	; HL <= SONG data address
LP5:
	LD	D,(IY+02)	; TONE length
LP2:
	LD	B,07H
LP1:
	LD	C,(HL)
	CALL	OUTDT
	RET	C
	INC	HL
	DJNZ	LP1
	DEC	D
	JR	NZ,LP2

	LD	D,(IY+00)	; DATA length
LP4:
	LD	C,(IY+03)	; data #1
	CALL	OUTDT
	RET	C
	LD	B,05H
LP3:
	LD	C,00H		; data #2-6
	CALL	OUTDT
	RET	C
	DJNZ	LP3

	LD	C,(IY+04)	; data #1
	CALL	OUTDT
	RET	C
	DEC	D
	JR	NZ,LP4

	INC	IY
	INC	IY
	INC	IY
	INC	IY
	INC	IY
	DEC	E
	JR	NZ,LP5

	LD	A,011H
	OUT	(0F0H),A	; 0x0000-0x3FFF ROM read
	EI

	XOR	A
	LD	(ERRFLAG),A
	RET

END
